﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Security.Cryptography;

using NetSoapClient.ServiceCerberusFtpSoap;

namespace NetSoapClient
{
    public partial class NetSoapClientForm : Form
    {
        public NetSoapClientForm()
        {
            InitializeComponent();
        }

        private void NetSoapClientForm_Load(object sender, EventArgs e)
        {



        }

        private Credentials getCredentials(string username, string password)
        {
            Credentials cred = new Credentials();
            cred.user = username;
            cred.password = password;

            return cred;
        }

        private Credentials getCredentials()
        {
            return getCredentials(textBoxAdminUsername.Text, textBoxAdminPassword.Text);
        }

        bool isServerStarted()
        {
            bool isStarted = false;

            try
            {

                CerberusFTPServicePort client = new CerberusFTPServicePortClient();


                ServerStartedRequest1 req = new ServerStartedRequest1();
                req.ServerStartedRequest = new ServerStartedRequest();
                req.ServerStartedRequest.credentials = getCredentials();

                for (int i = 0; i < 1; i++) {

                    ServerStartedResponse1 response = client.ServerStarted(req);

                    if (response != null && response.ServerStartedResponse != null) {
                        isStarted = response.ServerStartedResponse.result;
                        listBoxLog.Items.Add("Is Server Started? : " + isStarted);
                    }
                }
            }
            catch (Exception ex)
            {
                listBoxLog.Items.Add("Exception: " + ex.Message);
            }

            return isStarted;
        }

        private void buttonAddUser_Click(object sender, EventArgs e)
        {
            listBoxLog.Items.Clear();
            try
            {
                CerberusFTPServicePort client = new CerberusFTPServicePortClient();

                AddUserRequest1 req = new AddUserRequest1();
                req.AddUserRequest = new AddUserRequest();
                req.AddUserRequest.credentials = getCredentials();

                for (int i = 0; i < 1; i++) {
 
                    // Fill in the user details
                    User newUser = new User();

                    newUser.name = textBoxUsername.Text;
                    newUser.email = "someemail" + i + "@cerberusllc.com";
                    newUser.desc = "A test SOAP-added user";
                    newUser.fname = "First";
                    newUser.sname = "Last";
                    newUser.tel = "555-1212";
               
                    // We assign a plain text password for the user.  The server will hash it upon receipt, based on the
                    // current password policy settings, and only store the password's hash.

                    // You can also specify hashes (convert the byte array to a hex string), including salted hashes.  
                    // If you happen to have a salted hash, make sure you prepend the salt to the hash byte array before
                    // converting it to a hex string.  
                    // The salt comes first, followed by the hash.
                    // When the server decodes the hex string to a byte array, any extra bytes beyond the size of the hash type will
                    // be assumed to be the salt value.
                    // Those salt bytes will be taken from the beginning of the byte array.
                    Password pass = new Password();
                    pass.value = textBoxPassword.Text;
                    pass.type = PasswordType.plain;
                    pass.noExpire = false;
                    pass.lastChange = DateTime.Now;

                    newUser.password = pass;

                    // We currently only allow one group. API is designed to allow more than one to be specified for future
                    // expansion
                    newUser.groupList = new groupMember[1];
                    newUser.groupList[0] = new groupMember();
                    newUser.groupList[0].name = "ad_group";

                    // Override the default group attributes for this user
                    newUser.maxLoginsAllowed = new UserPropertyInt();
                    newUser.maxLoginsAllowed.valueSpecified = true;
                    newUser.maxLoginsAllowed.value = (int)numericUpDownMaxLogins.Value;
                    newUser.maxLoginsAllowed.priority = UserPropertyPriority.user;
                    newUser.maxLoginsAllowed.prioritySpecified = true;

                    // Override the default group attributes for this user
                    newUser.isSimpleDirectoryMode = new UserPropertyBool();
                    newUser.isSimpleDirectoryMode.valueSpecified = true;
                    newUser.isSimpleDirectoryMode.value = false;
                    newUser.isSimpleDirectoryMode.priority = UserPropertyPriority.user;
                    newUser.isSimpleDirectoryMode.prioritySpecified = true;

                    // Override the default group attributes for this user
                    newUser.isDisabled = new UserPropertyBool();
                    newUser.isDisabled.valueSpecified = true;
                    newUser.isDisabled.value = checkBoxIsDisabled.Checked;
                    newUser.isDisabled.priority = UserPropertyPriority.user;
                    newUser.isDisabled.prioritySpecified = true;

                    // Override the default group attributes for this user
                    newUser.authMethod = new UserPropertyAuthentication();
                    newUser.authMethod.methodSpecified = true;
                    newUser.authMethod.method = AuthenticationMethod.password_and_public_key;
                    newUser.authMethod.contentType = AuthenticationMethodContentType.filePath;
                    newUser.authMethod.contentTypeSpecified = true;
                    newUser.authMethod.Value = "c:\\ftp\\ssh_keys\\someuser.pub";
                    newUser.isDisabled.priority = UserPropertyPriority.user;
                    newUser.isDisabled.prioritySpecified = true;

                    // Override the default group attributes for this user
                    newUser.ipAllowedList = new UserPropertyString();
                    newUser.ipAllowedList.priority = UserPropertyPriority.user;
                    newUser.ipAllowedList.prioritySpecified = true;
                    newUser.ipAllowedList.value = "127.0.0.1,192.168.0.1,192.168.1.100";

                    VirtualDirectory[] vds = new VirtualDirectory[1];
                    vds[0] = new VirtualDirectory();

                    vds[0].name = textBoxVdName.Text;
                    vds[0].path = textBoxVdPath.Text;

                    vds[0].permissions = new DirectoryPermissions();
                    vds[0].permissions.allowUpload = checkBoxUp.Checked;
                    vds[0].permissions.allowDownload = checkBoxDown.Checked;
                    vds[0].permissions.allowDisplayHidden = checkBoxHidden.Checked;
                    vds[0].permissions.allowRename = checkBoxRen.Checked;
                    vds[0].permissions.allowDelete = checkBoxDel.Checked;
                    vds[0].permissions.allowDirectoryCreation = checkBoxCreateDir.Checked;

                    newUser.rootList = vds;

                    req.AddUserRequest.User = newUser;

                    AddUserResponse1 response = client.AddUser(req);

                    if (response != null && response.AddUserResponse != null)
                    {
                        listBoxLog.Items.Add("New User added result: " + response.AddUserResponse.result + " : " + response.AddUserResponse.message);
                    }
                }

            }
            catch (Exception ex)
            {
                listBoxLog.Items.Add("Exception: " + ex.Message);
            }
        }


        public static byte[] StrToByteArray(string str)
        {
            System.Text.UTF8Encoding encoding = new System.Text.UTF8Encoding();
            return encoding.GetBytes(str);
        }

        // Function to convert a string password to a 20-byte SHA1 hash
        public int[] getSHA1FromPassword(string strPassword)
        {
            // Compute the SHA1 hash of the password
            byte[] data = StrToByteArray(textBoxPassword.Text);
            byte[] shaResult;

            SHA1 sha = new SHA1CryptoServiceProvider();
            // This is one implementation of the abstract class SHA1.
            shaResult = sha.ComputeHash(data);

            int[] returnResult = new int[shaResult.Length];
            for (int i = 0; i < shaResult.Length; i++ )
            {
                returnResult[i] = shaResult[i];
            }

            return returnResult;
        }


        private void toolStripButtonStartServer_Click(object sender, EventArgs e)
        {
            listBoxLog.Items.Clear();
            try
            {
                CerberusFTPServicePort client = new CerberusFTPServicePortClient();

                StartServerRequest1 req = new StartServerRequest1();
                req.StartServerRequest = new StartServerRequest();
                req.StartServerRequest.credentials = getCredentials();


                StartServerResponse1 response = client.StartServer(req);

                if (response != null && response.StartServerResponse != null)
                {
                    listBoxLog.Items.Add("Server Started Result: " + response.StartServerResponse.result);
                }
            }
            catch (Exception ex)
            {
                listBoxLog.Items.Add("Exception: " + ex.Message);
            }
            isServerStarted();
        }

        private void toolStripButtonStopServer_Click(object sender, EventArgs e)
        {
            listBoxLog.Items.Clear();
            try
            {
                CerberusFTPServicePort client = new CerberusFTPServicePortClient();

                StopServerRequest1 req = new StopServerRequest1();
                req.StopServerRequest = new StopServerRequest();
                req.StopServerRequest.credentials = getCredentials();


                StopServerResponse1 response = client.StopServer(req);

                if (response != null && response.StopServerResponse != null)
                {
                    listBoxLog.Items.Add("Server Stopped Result: " + response.StopServerResponse.result);
                }
            }
            catch (Exception ex)
            {
                listBoxLog.Items.Add("Exception: " + ex.Message);
            }
            isServerStarted();
        }

        private void buttonDir_Click( object sender, EventArgs e ) {

            using (FolderBrowserDialog dlg = new FolderBrowserDialog())
            {
                dlg.Description = "Select a folder";
                if (dlg.ShowDialog() == DialogResult.OK)
                {
                    textBoxVdPath.Text =  dlg.SelectedPath;
                }
            }            
        }

        private void buttonRetrieveUser_Click( object sender, EventArgs e ) {
            
            string user = comboBoxUserList.Text;


            listBoxLog.Items.Clear();
            try {
                CerberusFTPServicePort client = new CerberusFTPServicePortClient();

                BlockAddressRequest1 reqBlock = new BlockAddressRequest1();
                reqBlock.BlockAddressRequest = new BlockAddressRequest();
                reqBlock.BlockAddressRequest.credentials = getCredentials();
                reqBlock.BlockAddressRequest.ipaddress = "192.168.0.5";
                BlockAddressResponse1 response1 = client.BlockAddress(reqBlock);



                GetUserInformationRequest1 req = new GetUserInformationRequest1();
                req.GetUserInformationRequest = new GetUserInformationRequest();
                req.GetUserInformationRequest.credentials = getCredentials();

                req.GetUserInformationRequest.userName = user;


                GetUserInformationResponse1 response = client.GetUserInformation(req);

                if (response != null && response.GetUserInformationResponse != null) {
                    listBoxLog.Items.Add("GetUserInformation Result: " + response.GetUserInformationResponse.result);
                
                    GetUserInformationResponse res = response.GetUserInformationResponse;
                    User usr = res.UserInformation;

                    if (usr != null) {
                        textBoxUsername.Text = usr.name;
                        if (usr.isAnonymous != null) {
                            checkBoxIsAnonymous.Checked = usr.isAnonymous.value;
                        }
                        if (usr.isDisabled != null) {
                            checkBoxIsDisabled.Checked = usr.isDisabled.value;
                        }
                        if (usr.maxLoginsAllowed != null) {
                            numericUpDownMaxLogins.Value = usr.maxLoginsAllowed.value;
                        }

                    }
                }
            }
            catch (Exception ex) {
                listBoxLog.Items.Add("Exception: " + ex.Message);
            }
        }

        private void buttonLoadUsers_Click( object sender, EventArgs e ) {

            listBoxLog.Items.Clear();
            try {
                CerberusFTPServicePort client = new CerberusFTPServicePortClient();

                GetUserListRequest1 req = new GetUserListRequest1();
                req.GetUserListRequest = new GetUserListRequest();
                req.GetUserListRequest.credentials = getCredentials();



                GetUserListResponse1 response = client.GetUserList(req);

                if (response != null && response.GetUserListResponse != null) {
                    listBoxLog.Items.Add("GetUserList Result: " + response.GetUserListResponse.result);

                    GetUserListResponse res = response.GetUserListResponse;

                    comboBoxUserList.Text = "";
                    comboBoxUserList.Items.Clear();
                    foreach (string str in res.UserList ) {
                        comboBoxUserList.Items.Add(str);
                    }
                }
            }
            catch (Exception ex) {
                listBoxLog.Items.Add("Exception: " + ex.Message);
            }
        }

        private void buttonConnect_Click(object sender, EventArgs e)
        {
            listBoxLog.Items.Clear();
            isServerStarted();
        }

        private void button1_Click(object sender, EventArgs e)
        {

            try
            {
                CerberusFTPServicePort client = new CerberusFTPServicePortClient();

                SharePublicFileRequest1 reqFile = new SharePublicFileRequest1();
                reqFile.SharePublicFileRequest = new SharePublicFileRequest();

                reqFile.SharePublicFileRequest.credentials = getCredentials();
                reqFile.SharePublicFileRequest.username = "shareUser";
                reqFile.SharePublicFileRequest.password = "sharePassword";
                reqFile.SharePublicFileRequest.sharePassword = "";

                reqFile.SharePublicFileRequest.shareRemoteFilePath = "/ftp1.jpg";
                reqFile.SharePublicFileRequest.shareDurationHours = 48;
                reqFile.SharePublicFileRequest.shareDeleteOnExpire = false;
                reqFile.SharePublicFileRequest.shareDeleteOnExpireSpecified = true;

                reqFile.SharePublicFileRequest.shareNotifyOnDownload = true;
                reqFile.SharePublicFileRequest.shareNotifyOnDownloadSpecified = true;

                reqFile.SharePublicFileRequest.shareNotifyRecipient = new EmailRecipient[] { new EmailRecipient() { name = "Cerberus User", email = "user_test@test.com" } };

                reqFile.SharePublicFileRequest.publicHost = "localhost";
                reqFile.SharePublicFileRequest.publicPort = 443;
                reqFile.SharePublicFileRequest.publicIsSSL = true;


                SharePublicFileResponse1 response1 = client.SharePublicFile(reqFile);
                if (response1.SharePublicFileResponse.success)
                {
                    listBoxLog.Items.Add("Share link: " + response1.SharePublicFileResponse.link);
                }
                else {

                    listBoxLog.Items.Add("Share error: " + response1.SharePublicFileResponse.message);
                }


                reqFile.SharePublicFileRequest.shareRemoteFilePath = "/test";
                reqFile.SharePublicFileRequest.shareDurationHours = 72;

                reqFile.SharePublicFileRequest.publicHost = "localhost";
                reqFile.SharePublicFileRequest.publicPort = 443;
                reqFile.SharePublicFileRequest.publicIsSSL = true;


                response1 = client.SharePublicFile(reqFile);
                if (response1.SharePublicFileResponse.success)
                {
                    listBoxLog.Items.Add("Share link: " + response1.SharePublicFileResponse.link);
                }
                else
                {

                    listBoxLog.Items.Add("Share error: " + response1.SharePublicFileResponse.message);
                }


                reqFile.SharePublicFileRequest.shareRemoteFilePath = "/test2";
                reqFile.SharePublicFileRequest.shareDurationHours = 72;

                reqFile.SharePublicFileRequest.publicHost = "localhost";
                reqFile.SharePublicFileRequest.publicPort = 443;
                reqFile.SharePublicFileRequest.publicIsSSL = true;


                response1 = client.SharePublicFile(reqFile);
                if (response1.SharePublicFileResponse.success)
                {
                    listBoxLog.Items.Add("Share link: " + response1.SharePublicFileResponse.link);
                }
                else
                {

                    listBoxLog.Items.Add("Share error: " + response1.SharePublicFileResponse.message);
                }

            }
            catch (Exception ex)
            {
                listBoxLog.Items.Add("Exception: " + ex.Message);
            }

        }


    }
}
